SRXBK | Back to Index page

| Prolog Control Block Contents SRXBK DSECT Storage Layout Cross Reference (Contains links to field and bit definitions) |
Programming Interface Information: This information is NOT intended to be used as Programming Interfaces of z/VM.

SRXBK Prolog | Top of page

     NAME       : HCPSRXBK
     DESCRIPTION: System Resource Management block extensions
     DSECT      : SRXBK
     FUNCTION   : HCPSRXBK contains original SRMBK fields which are
                  duplicated for Mixed-Engine partitions.  These
                  fields are used by the System Resource Manager
                  (Scheduler) in the maintainance of user lists and
                  calculation of various scheduling parameters.
     LOCATED BY : SRMXTBL table of SRXBK pointers by processor
                  type
     CREATED BY : HCPIST during system initialization
     DELETED BY : Never deleted
     REFERENCES : None
     SERIALIZED : Scheduler lock (SRMSLOCK)
     RELOCATION CONSIDERATIONS : None
     COMPATIBILITY AND MIGRATION CONCERNS : An SRXBK exists for
                  each processor type that is valid in a Mixed-Engines
                  configuration.  Prior to Mixed-Engines support, these
                  fields were global scheduler fields.  Now they must
                  be viewed as valid for a particular processor type
                  only.  For example, when processing the SRXBK for
                  type zAAP, SRXMXSHR is the largest SHARE of system
                  that can be delivered to a single VMDBK of type
                  zAAP.

SRXBK Control Block Content | Top of page

     SRXBK DSECT
    Top of page

    Hex   Dec Type/Val   Lng Label (dup)    Comments
    ---- ---- --------- ---- -------------- --------
    0000    0 Structure      SRXBK          System Resource Management block extensions
    0000    0 Signed       4 SRXDLSCN       Dispatch list scan header. This
                                            is the point at which HCPSTK's
                                            LINKDS subroutine is to begin
                                            scanning the dispatch list for an
                                            insertion point whenever adding a
                                            user
    0004    4 Address      4 SRXDLADD       Pointer to the last VMDBK added
                                            to the D-list ahead of ATOD. Used
                                            to reduce scans in the list.
                 Timing Parameters
                 NOTES      : The assembler construct 'FL8S12' is used to
                 generate a fixed-point number which represents a
                 time value (in microseconds) in TOD clock format
                 or CPU timer format.  'FL8S12E6' is used when
                 specifying a time value in seconds (rather than
                 microseconds).
    0008    8 Signed       8 SRXHIDSP       Dispatching priority of the
                                            highest priority user on the
                                            dispatch list at the time of the
                                            last major reshuffle (HCPDSBRV)
                                            less an adjustment interval to
                                            allow for continuing transactions
                                            returning to the dispatch list.
                                            The highest priority user has the
                                            lowest value of VMDDPRTY. This
                                            field is the basis for computing
                                            field DSVPRIOR in the PLDV.
                                            DSVPRIOR = VMDDPRTY - SRXHIDSP.
                                            (at least 32 bits of the result).
    0010   16 Signed       8 SRXATOD        Artificial TOD. This TOD only
                                            advances at the rate the system
                                            is running user work. Updates
                                            serialized by SRMSLOCK exclusive
                                            or SRMSLOCK shared plus SRMATDLK
                                            exclusive.
    0018   24 Signed       4 SRXTOTLS (0)   An equate used as an index base
                                            to reference one of the next two
                                            fields, srmreldl and srmabsdl.
                                            Code depends on these two fields
                                            being fullwords and following IN
                                            THE GIVEN ORDER.
    0018   24 Signed       4 SRXRELDL       The sum of the relative shares of
                                            all RELATIVE share holders
                                            (excluding dedicated VMDBKs)
                                            currently in the dispatch list.
                                            This field is protected by the
                                            scheduler lock.
    001C   28 Signed       4 SRXABSDL       The sum of the absolute shares of
                                            all VMDBKs (excluding dedicated
                                            VMDBKs) currently in the dispatch
                                            list. This field is protected by
                                            the scheduler lock.
    0020   32 Signed       4 SRXTOTDE (0)   An equate used as an index base
                                            to reference one of the next two
                                            fields, srmrelde and srmabsde.
                                            Code depends on these two fields
                                            being fullwords and following in
                                            the given order.
    0020   32 Signed       4 SRXRELDE       The sum of the relative shares of
                                            all relative share holders
                                            currently in the eligible and
                                            dispatch list. This field is
                                            protected by the scheduler lock.
    0024   36 Signed       4 SRXABSDE       The sum of the absolute shares of
                                            all VMDBKs currently in the
                                            eligible and dispatch list. This
                                            field is protected by the
                                            scheduler lock.
    0028   40 Signed       2 SRXNCPUA       The number of CPUs available to
                                            schedule time on for
                                            non-dedicated users. This field
                                            is protected by the scheduler
                                            lock.
    002A   42 Signed       2 SRXPKCNT       The number of parked CPUs.
    002C   44 Address      4 SRXLLIST       Anchor for the limit-list.
                                            Contains address of 1st VMDBK in
                                            list, or zero if list is empty.
                                            VMDBKs are forward and backward
                                            chained via VMDLFPNT & VMDLBPNT.
    0030   48 Dbl-Word     8 SRXATODD       A timestamp (TOD). The deadline
                                            for current ATOD-interval to end.
                                            Each CPU will copy this into its
                                            PFXATODD. But PFXATODD will often
                                            be an iteration behind SRXATODD.
                                            Updates are serialized by
                                            SRMATDLK exclusive.
    0038   56 Dbl-Word     8 SRXCHKIN       A timestamp (TOD). Time when the
                                            first-checker CPU last checked in
                                            (to start current ATOD-interval).
                                            Equals PFXCHKIN of first-checker.
                                            Updates are serialized by
                                            SRMATDLK exclusive.
    0040   64 Dbl-Word     8 SRXCHKTW       A timestamp (TOD). Time when the
                                            tracked-wait masks (SRXASKT1 and
                                            SRXASKT2) should next be checked.
                                            (Set to something like TOD+10ms.)
                                            Updates are serialized by
                                            SRMATDLK exclusive.
    0048   72 Signed       8 SRXATOD2       Artificial TOD2. This TOD
                                            advances at the same rate as the
                                            TOD clock. It is updated each
                                            time SRXATOD is adjusted. This
                                            field is used to determine when a
                                            VMDBK should be dropped from the
                                            limit list. Updates serialized by
                                            SRMATDLK exclusive.
    0050   80 Bitstring   64 SRXASKTW       Mask has a bit for each logical
                                            CPU. Bit is on if the CPU is
                                            currently in "tracked-wait" mode.
                                            Updates serialized by SRMSLOCK
                                            exclusive or SRMSLOCK shared plus
                                            SRMATDLK exclusive.
    0090  144 Bitstring   64 SRXASKT1       Mask has a bit for each logical
                                            CPU. Bit is on if CPU performed
                                            an ATOD-check-in since mask was
                                            last reset (as timed by
                                            SRMASKTM). Updates are serialized
                                            by SRMATDLK exclusive.
    00D0  208 Bitstring   64 SRXASKT2       Mask has a bit for each logical
                                            CPU. Bit is on if CPU performed
                                            an ATOD-check-in during previous
                                            interval (as timed by SRMASKTM).
                                            Updates are serialized by
                                            SRMATDLK exclusive.
    0110  272 Signed       4 SRXTRKCT       Count of tracked-wait-mode CPUs.
                                            Updates serialized by SRMSLOCK
                                            exclusive or SRMSLOCK shared plus
                                            SRMATDLK exclusive.
    0114  276 Address      4 *              Reserved for IBM use
           SRXRTHRU is a table used in normalizing
           users' VMDRTHRUs.  (VMDRTHRU is the user's "required
           throughput" i.e., his SHARE after it has been adjusted to
           compensate him for any delay in the eligible list.)
    0118  280 Signed       4 SRXRTHRU (0)   Start of array (table) of sums of
                                            VMDRTHRU values for all VMDBKs in
                                            the dispatch list.
    0118  280 Signed       4 SRXRTHRN       Total VMDRTHRU of VMDBKs in the
                                            dispatch list which are not cur-
                                            rently hitting their max-SHAREs.
    011C  284 Signed       4 SRXRTHRL       Total VMDRTHRU of VMDBKs in the
                                            dispatch list which are current-
                                            ly hitting their max-SHAREs.
                                            (LIMITed and hitting the limit.)
    0120  288 Signed       4 SRXRTHRZ (0)   End of array (table).
    0120  288 Signed       4 * (2)          Reserved for IBM use
                 General Data Fields
    0128  296 Signed       4 SRXMXSHR       Largest SHARE of system that can
                                            be delivered to a single VMDBK.
                                            It is the reciprocal of SRXNCPUA.
                                            (E.g., 0.25 on a 4-way system.)
    012C  300 Signed       4 SRXLLCNT       Count of adds to the limit-list.
                                            This count is only approximate,
                                            it does not include adds result-
                                            from virtual-MP priority drop.
    0130  304 Signed       4 SRXCONLL       Count of users actually ON the
                                            Limit List. This count is
                                            serialized by the scheduler lock.
    0134  308 Address      4 SRXDVLST       Anchor into the linked list of
                                            PLDV's linked by DSVNXTDV.
          The following fields are bit masks for which each real
          processor has a corresponding unique bit.
    0138  312 Bitstring   64 SRXLCPUA       Mask containing the logical CPU
                                            ids (PFXLCPUA) of CPUs which are
                                            online, non-dedicated, and
                                            unparked. (The difference of
                                            SRXNCPUA and SRXPKCNT should tell
                                            how many bits are on in
                                            SRXLCPUA.) See also SYSLCPUA,
                                            which is similar, but also shows
                                            dedicated, parked and also
                                            offline CPUs whose prefix pages
                                            have not been freed.
    0178  376 Bitstring   64 SRXPKMSK       Mask containing the logical CPU
                                            ids (PFXLCPUA) of CPUs which are
                                            parked. (The counter SRXPKCNT
                                            indicates how many bits are on in
                                            SRXPKMSK.) See also SRMPKMSK,
                                            which is a mask for parked CPUs
                                            of all types.
    01B8  440 Address      4 SRXTRQWT       Points to TRQBK used to bring us
                                            out of wait state when it is time
                                            to dequeue VMDBKs from
                                            limit-list.
    01BC  444 Bitstring    1 SRXFLAGS       General flags
              1... ....      SRXSYSMP       X'80' SRXSYSMP This CPU type can
                                            dispatch SYSTEMMP work (CP + IFL)
    01BD  445 Bitstring    1 SRXEXUSE       SRM EXCESSUSE field
              00000010       SRXEXHGH       16 SRXEXHGH -Indicates the system
                                            should be aggressive in using
                                            unentitled CPU/core capacity.
              00000008       SRXEXMED       8 SRXEXMED -Indicates the system
                                            should be moderately aggressive
                                            in using unentitled CPU/core
                                            capacity.
              00000001       SRXEXLOW       1 SRXEXLOW -Indicates the system
                                            should not be aggressive in using
                                            unentitled CPU/core capacity.
              00000002       SRXEXNON       2 SRXEXNON -Indicates the system
                                            should not use unentitled
                                            CPU/core capacity.
    01BE  446 Bitstring    1 SRXWRKCI       Workload confidence interval -
                                            integer between 50 and 99,
                                            specifying the percentage
                                            confidence level
    01BF  447 Bitstring    1 SRXTVCNF       T/V ratio confidence percentage -
                                            integer between 50 and 99,
                                            specifying the confidence level
                                            of the T/V ratio ceiling
                                            projection.
    01C0  448 Signed       4 SRXCPPAD       SRM CPUPAD value, a scaled number
                                            where X'00010000' represents one
                                            CPU/core
    01C4  452 Signed       2 SRXPMAX        Maximum number of CPUS that can
                                            be parked in an interval
    01C6  454 Bitstring    2 *              Reserved for IBM use
    01C8  456 Address      4 SRXLASDV       HL address of the last DSVBK to
                                            which a VMDBK was assigned during
                                            the round-robin phase of
                                            rebalance which is used when all
                                            capacity of a given type is
                                            depleted. Reset at the start of
                                            each rebalance
    01CC  460 Signed       4 SRXENTVM       This is a scaled number between
                                            X'00000001' and X'00010000'
                                            representing the portion of a
                                            real CPU to which vertical medium
                                            CPUs are entitled. Serialized by
                                            Vary Proc lock.
    01D0  464 Signed       4 SRXNOTVH       Capacity assigned to all
                                            CPUs/cores other than vertical
                                            high CPUs/cores.
    01D4  468 Bitstring    4 *              Reserved for IBM use.
    01D8  472 Dbl-Word     8 SRXNICPF (10)  Circular array of Next Interval
                                            Capacity Factors. RCCTOPDX is to
                                            be used as an index to find the
                                            most recent element. Each element
                                            is a factor to be used to adjust
                                            the remaining capacity during the
                                            next interval. This value is
                                            stored in floating point format.
    0228  552 Dbl-Word     8 SRXNIPAD (10)  Circular array of Next Interval
                                            Tolerance Padding values.
                                            RCCTOPDX is to be used as an
                                            index to find the most recent
                                            element. Stored in floating point
                                            format.
    0278  632 Signed       4 SRXLIUSG (10)  Circular array of Total CPU usage
                                            of this type during the last
                                            interval. RCCTOPDX is to be used
                                            as an index to find the most
                                            recent element. This value is
                                            scaled such that x'10000' equals
                                            one full CPU.
    02A0  672 Signed       4 SRXVMDCT (10)  Circular array of counts of the
                                            number of VMDBKs on the global
                                            cyclic list with this dispatch
                                            CPU type when gathering informa-
                                            tion to be used for dispatch
                                            vector rebalance. RCCTOPDX is to
                                            be used as an index to find the
                                            most recent element.
    02C8  712 Signed       4 SRXACGUS (10)  Circular array of the average CPU
                                            usage of the VMDBKs of this type
                                            in the last interval. RCCTOPDX is
                                            to be used as an index to find
                                            the most recent element. This
                                            value is scaled such that
                                            x'10000' equals one full CPU.
    02F0  752 Signed       4 SRXMCF         Maximum Capacity Factor for this
                                            CPU type. MCF=1 when MT is not
                                            enabled or RCCACMNT=1 for the CPU
                                            type corresponding to this SRXBK.
                                            Scaled by
                                            HisMT_Entry_kMetricFactor or by
                                            shifting the value using
                                            HisMT_Entry_kMetricShift Updated
                                            only by a singleton task in
                                            HCPMTCMC.
    02F4  756 Signed       4 SRXCORCT       Count of cores of this CPU type
                                            with online non-dedicated parked
                                            and unparked processors.
                                            Serialized by the Scheduler lock.
              00000020       SRXHISTSZ      32 Number of entries in
                                            scheduling history array
              00000008       SRXNumInts     8 Number of entries in the
                                            scheduling history array that are
                                            actually used to track scheduling
                                            history
    02F8  760 Dbl-Word     8 SRXATODHIST (32)
                                            History of ATOD values by
                                            scheduling interval
    03F8 1016 Dbl-Word     8 SRXSCHEDINT    Current scheduling interval
                                            number
              .... 1.1.      SRXSCHEDINTLN  10 SRXSCHEDINTLN Length (in
                                            number of first-checker
                                            intervals) of a scheduling
                                            interval
    0400 1024 Signed       4 SRXNXTINT      Count of first-checks left until
                                            we start a new scheduling
                                            interval
    0404 1028 Signed       4 *              Reserved for IBM use
    0408 1032 Signed       4 SRXTOTLG (0)   Sum of shares for all logged on
                                            users.
    0408 1032 Signed       4 SRXRELLG       Sum of relative shares for all
                                            logged on VMDBKs. (excluding
                                            dedicated VMDBKs)
    040C 1036 Signed       4 SRXABSLG       Sum of absolute shares for all
                                            logged on VMDBKs. (excluding
                                            dedicated VMDBKs)
    0410 1040 Signed       2 SRXNUMVH       Count of VH CPUs/Cores of this
                                            CPU type reported for our
                                            partition by Diag x'204'.
    0412 1042 Signed       2 SRXNUMVM       Count of VM CPUs/Cores of this
                                            CPU type reported for our
                                            partition by Diag x'204'.
    0414 1044 Signed       2 SRXNUMVL       Count of VL CPUs/Cores of this
                                            CPU type reported for our
                                            partition by Diag x'204'.
    0416 1046 Signed       2 *              Reserved for IBM use.
              00000083       SRXSIZE        (*-SRXBK+7)/8 size in double
                                            words
              00000418       SRXBSIZE       SRXSIZE*8 size in bytes
              00000005       SRXCSIZE       (SRXBSIZE+255)/256 size in cache
                                            lines

SRXBK Storage Layout | Top of page

    *** SRXBK - System Resource Management block extensions
    *
    *     +---------------------------+---------------------------+
    *   0 |         SRXDLSCN          |         SRXDLADD          |
    *     +---------------------------+---------------------------+
    *   8 |                       SRXHIDSP                        |
    *     +-------------------------------------------------------+
    *  10 |                       SRXATOD                         |
    *     +---------------------------+---------------------------+
    *  18 |         SRXRELDL          |         SRXABSDL          |
    *     +---------------------------+---------------------------+
    *  20 |         SRXRELDE          |         SRXABSDE          |
    *     +-------------+-------------+---------------------------+
    *  28 |  SRXNCPUA   |  SRXPKCNT   |         SRXLLIST          |
    *     +-------------+-------------+---------------------------+
    *  30 |                       SRXATODD                        |
    *     +-------------------------------------------------------+
    *  38 |                       SRXCHKIN                        |
    *     +-------------------------------------------------------+
    *  40 |                       SRXCHKTW                        |
    *     +-------------------------------------------------------+
    *  48 |                       SRXATOD2                        |
    *     +-------------------------------------------------------+
    *  50 |                                                       |
    *     =                       SRXASKTW                        =
    *     |                                                       |
    *     +-------------------------------------------------------+
    *  90 |                                                       |
    *     =                       SRXASKT1                        =
    *     |                                                       |
    *     +-------------------------------------------------------+
    *  D0 |                                                       |
    *     =                       SRXASKT2                        =
    *     |                                                       |
    *     +---------------------------+---------------------------+
    * 110 |         SRXTRKCT          |///////////////////////////|
    *     +---------------------------+---------------------------+
    * 118 |         SRXRTHRN          |         SRXRTHRL          |
    *     +---------------------------+---------------------------+
    * 120 |///////////////////////////////////////////////////////|
    *     +---------------------------+---------------------------+
    * 128 |         SRXMXSHR          |         SRXLLCNT          |
    *     +---------------------------+---------------------------+
    * 130 |         SRXCONLL          |         SRXDVLST          |
    *     +---------------------------+---------------------------+
    * 138 |                                                       |
    *     =                       SRXLCPUA                        =
    *     |                                                       |
    *     +-------------------------------------------------------+
    * 178 |                                                       |
    *     =                       SRXPKMSK                        =
    *     |                                                       |
    *     +---------------------------+------+------+------+------+
    * 1B8 |         SRXTRQWT          |:FLAGS|:EXUSE|:WRKCI|:TVCNF|
    *     +---------------------------+------+------+------+------+
    * 1C0 |         SRXCPPAD          |  SRXPMAX    |/////////////|
    *     +---------------------------+-------------+-------------+
    * 1C8 |         SRXLASDV          |         SRXENTVM          |
    *     +---------------------------+---------------------------+
    * 1D0 |         SRXNOTVH          |///////////////////////////|
    *     +---------------------------+---------------------------+
    * 1D8 |                                                       |
    *     =                       SRXNICPF                        =
    *     |                                                       |
    *     +-------------------------------------------------------+
    * 228 |                                                       |
    *     =                       SRXNIPAD                        =
    *     |                                                       |
    *     +-------------------------------------------------------+
    * 278 |                                                       |
    *     =                       SRXLIUSG                        =
    *     |                                                       |
    *     +-------------------------------------------------------+
    * 2A0 |                                                       |
    *     =                       SRXVMDCT                        =
    *     |                                                       |
    *     +-------------------------------------------------------+
    * 2C8 |                                                       |
    *     =                       SRXACGUS                        =
    *     |                                                       |
    *     +---------------------------+---------------------------+
    * 2F0 |          SRXMCF           |         SRXCORCT          |
    *     +---------------------------+---------------------------+
    * 2F8 |                                                       |
    *     =                     SRXATODHIST                       =
    *     |                                                       |
    *     +-------------------------------------------------------+
    * 3F8 |                     SRXSCHEDINT                       |
    *     +---------------------------+---------------------------+
    * 400 |        SRXNXTINT          |///////////////////////////|
    *     +---------------------------+---------------------------+
    * 408 |         SRXRELLG          |         SRXABSLG          |
    *     +-------------+-------------+-------------+-------------+
    * 410 |  SRXNUMVH   |  SRXNUMVM   |  SRXNUMVL   |/////////////|
    *     +-------------+-------------+-------------+-------------+
    * 418
    *
    *** SRXBK - System Resource Management block extensions

SRXBK Cross Reference | Top of page

    Symbol         Dspl Value
    -------------- ---- -----
    SRXABSDE       0024
    SRXABSDL       001C
    SRXABSLG       040C
    SRXACGUS       02C8
    SRXASKTW       0050
    SRXASKT1       0090
    SRXASKT2       00D0
    SRXATOD        0010
    SRXATODD       0030
    SRXATODHIST    02F8
    SRXATOD2       0048
    SRXBSIZE       0416 00000418
    SRXCHKIN       0038
    SRXCHKTW       0040
    SRXCONLL       0130
    SRXCORCT       02F4
    SRXCPPAD       01C0
    SRXCSIZE       0416 00000005
    SRXDLADD       0004
    SRXDLSCN       0000
    SRXDVLST       0134
    SRXENTVM       01CC
    SRXEXHGH       01BD 00000010
    SRXEXLOW       01BD 00000001
    SRXEXMED       01BD 00000008
    SRXEXNON       01BD 00000002
    SRXEXUSE       01BD
    SRXFLAGS       01BC
    SRXHIDSP       0008
    SRXHISTSZ      02F4 00000020
    SRXLASDV       01C8
    SRXLCPUA       0138
    SRXLIUSG       0278
    SRXLLCNT       012C
    SRXLLIST       002C
    SRXMCF         02F0
    SRXMXSHR       0128
    SRXNumInts     02F4 00000008
    SRXNCPUA       0028
    SRXNICPF       01D8
    SRXNIPAD       0228
    SRXNOTVH       01D0
    SRXNUMVH       0410
    SRXNUMVL       0414
    SRXNUMVM       0412
    SRXNXTINT      0400
    SRXPKCNT       002A
    SRXPKMSK       0178
    SRXPMAX        01C4
    SRXRELDE       0020
    SRXRELDL       0018
    SRXRELLG       0408
    SRXRTHRL       011C
    SRXRTHRN       0118
    SRXRTHRU       0118
    SRXRTHRZ       0120
    SRXSCHEDINT    03F8
    SRXSCHEDINTLN  03F8 0A
    SRXSIZE        0416 00000083
    SRXSYSMP       01BC 80
    SRXTOTDE       0020
    SRXTOTLG       0408
    SRXTOTLS       0018
    SRXTRKCT       0110
    SRXTRQWT       01B8
    SRXTVCNF       01BF
    SRXVMDCT       02A0
    SRXWRKCI       01BE

This information is based on z/VM 7.2.0 Last updated on 24 Jun 2020 at 09:30:49 EDT.
Copyright IBM Corporation, 1990, 2020